diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/object-factory.h ns-3.32/src/core/model/object-factory.h
--- ns-3.31/src/core/model/object-factory.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/object-factory.h	2020-10-06 15:35:43.000000000 -0700
@@ -57,9 +57,15 @@
   /**
    * Construct a factory for a specific TypeId by name.
    *
+   * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs
    * \param [in] typeId The name of the TypeId this factory should create.
+   * \param [in] args A sequence of name-value pairs of additional attributes to set.
+   *
+   * The args sequence can be made of any number of pairs, each consisting of a
+   * name (of std::string type) followed by a value (of const AttributeValue & type).
    */
-  ObjectFactory (std::string typeId);
+  template <typename... Args>
+  ObjectFactory (const std::string& typeId, Args&&... args);
 
   /**@{*/
   /**
@@ -82,10 +88,23 @@
   /**
    * Set an attribute to be set during construction.
    *
+   * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs
    * \param [in] name The name of the attribute to set.
    * \param [in] value The value of the attribute to set.
+   * \param [in] args A sequence of name-value pairs of additional attributes to set.
+   *
+   * The args sequence can be made of any number of pairs, each consisting of a
+   * name (of std::string type) followed by a value (of const AttributeValue & type).
+   */
+  template <typename... Args>
+  void Set (const std::string &name, const AttributeValue &value, Args&&... args);
+
+  /**
+   * Base case to stop the recursion performed by the templated version of this
+   * method.
    */
-  void Set (std::string name, const AttributeValue &value);
+  void Set (void)
+  { }
 
   /**
    * Get the TypeId which will be created by this ObjectFactory.
@@ -114,6 +133,13 @@
 
 private:
   /**
+   * Set an attribute to be set during construction.
+   *
+   * \param [in] name The name of the attribute to set.
+   * \param [in] value The value of the attribute to set.
+   */
+  void DoSet (const std::string &name, const AttributeValue &value);
+  /**
    * Print the factory configuration on an output stream.
    *
    * The configuration will be printed as a string with the form
@@ -154,38 +180,16 @@
  * Allocate an Object on the heap and initialize with a set of attributes.
  *
  * \tparam T \explicit The requested Object type.
- * \param [in] n1 Name of attribute
- * \param [in] v1 Value of attribute
- * \param [in] n2 Name of attribute
- * \param [in] v2 Value of attribute
- * \param [in] n3 Name of attribute
- * \param [in] v3 Value of attribute
- * \param [in] n4 Name of attribute
- * \param [in] v4 Value of attribute
- * \param [in] n5 Name of attribute
- * \param [in] v5 Value of attribute
- * \param [in] n6 Name of attribute
- * \param [in] v6 Value of attribute
- * \param [in] n7 Name of attribute
- * \param [in] v7 Value of attribute
- * \param [in] n8 Name of attribute
- * \param [in] v8 Value of attribute
- * \param [in] n9 Name of attribute
- * \param [in] v9 Value of attribute
+ * \tparam Args \deduced The type of the sequence of name-value pairs.
+ * \param [in] args A sequence of name-value pairs of the attributes to set.
  * \returns A pointer to a newly allocated object.
+ *
+ * The args sequence can be made of any number of pairs, each consisting of a
+ * name (of std::string type) followed by a value (of const AttributeValue & type).
  */
-template <typename T>
+template <typename T, typename... Args>
 Ptr<T>
-CreateObjectWithAttributes (std::string n1 = "", const AttributeValue & v1 = EmptyAttributeValue (),
-                            std::string n2 = "", const AttributeValue & v2 = EmptyAttributeValue (),
-                            std::string n3 = "", const AttributeValue & v3 = EmptyAttributeValue (),
-                            std::string n4 = "", const AttributeValue & v4 = EmptyAttributeValue (),
-                            std::string n5 = "", const AttributeValue & v5 = EmptyAttributeValue (),
-                            std::string n6 = "", const AttributeValue & v6 = EmptyAttributeValue (),
-                            std::string n7 = "", const AttributeValue & v7 = EmptyAttributeValue (),
-                            std::string n8 = "", const AttributeValue & v8 = EmptyAttributeValue (),
-                            std::string n9 = "", const AttributeValue & v9 = EmptyAttributeValue ()
-                            );
+CreateObjectWithAttributes (Args... args);
 
 
 ATTRIBUTE_HELPER_HEADER (ObjectFactory);
@@ -207,29 +211,28 @@
   return object->GetObject<T> ();
 }
 
-template <typename T>
+template <typename... Args>
+ObjectFactory::ObjectFactory (const std::string& typeId, Args&&... args)
+{
+  SetTypeId (typeId);
+  Set (args...);
+}
+
+template <typename... Args>
+void
+ObjectFactory::Set (const std::string &name, const AttributeValue & value, Args&&... args)
+{
+  DoSet (name, value);
+  Set (args...);
+}
+
+template <typename T, typename... Args>
 Ptr<T>
-CreateObjectWithAttributes (std::string n1, const AttributeValue & v1,
-                            std::string n2, const AttributeValue & v2,
-                            std::string n3, const AttributeValue & v3,
-                            std::string n4, const AttributeValue & v4,
-                            std::string n5, const AttributeValue & v5,
-                            std::string n6, const AttributeValue & v6,
-                            std::string n7, const AttributeValue & v7,
-                            std::string n8, const AttributeValue & v8,
-                            std::string n9, const AttributeValue & v9)
+CreateObjectWithAttributes (Args... args)
 {
   ObjectFactory factory;
   factory.SetTypeId (T::GetTypeId ());
-  factory.Set (n1, v1);
-  factory.Set (n2, v2);
-  factory.Set (n3, v3);
-  factory.Set (n4, v4);
-  factory.Set (n5, v5);
-  factory.Set (n6, v6);
-  factory.Set (n7, v7);
-  factory.Set (n8, v8);
-  factory.Set (n9, v9);
+  factory.Set (args...);
   return factory.Create<T> ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/time.cc ns-3.32/src/core/model/time.cc
--- ns-3.31/src/core/model/time.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/time.cc	2020-10-06 15:35:43.000000000 -0700
@@ -427,8 +427,31 @@
       break;
     }
 
-  int64x64_t v = timeU.m_time.To (timeU.m_unit);
-  os << v << unit;
+  double v = timeU.m_time.ToDouble (timeU.m_unit);
+
+  // Note: we must copy the "original" format flags because we have to modify them.
+  // std::ios_base::showpos is to print the "+" in front of the number for positive,
+  // std::ios_base::right is to add (eventual) extra space in front of the number.
+  //   the eventual extra space might be due to a std::setw (_number_), and
+  //   normally it would be printed after the number and before the time unit.
+
+  std::ios_base::fmtflags ff = os.flags ();
+
+  os << std::showpos << std::right << v << unit;
+
+  // And here we have to restore what we changed.
+  if (!(ff & std::ios_base::showpos))
+    {
+      os << std::noshowpos;
+    }
+  if (ff & std::ios_base::left)
+    {
+      os << std::left;
+    }
+  else if (ff & std::ios_base::internal)
+    {
+      os << std::internal;
+    }
 
   return os;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/version.cache ns-3.32/src/core/model/version.cache
--- ns-3.31/src/core/model/version.cache	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/model/version.cache	2020-10-06 20:43:49.986056808 -0700
@@ -0,0 +1,9 @@
+CLOSEST_TAG = '"ns-3.32"'
+VERSION_COMMIT_HASH = '"release"'
+VERSION_DIRTY_FLAG = '0'
+VERSION_MAJOR = '3'
+VERSION_MINOR = '32'
+VERSION_PATCH = '0'
+VERSION_RELEASE_CANDIDATE = '""'
+VERSION_TAG = '"ns-3.32"'
+VERSION_TAG_DISTANCE = '0'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/version.cc ns-3.32/src/core/model/version.cc
--- ns-3.31/src/core/model/version.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/model/version.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,163 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Mathew Bielejeski <bielejeski1@llnl.gov>
+ */
+
+#include "version.h"
+#include "ns3/version-defines.h"
+#include <sstream>
+
+/**
+ * \file
+ * \ingroup buildversion
+ * ns3::Version implementation
+ */
+
+namespace ns3 {
+
+std::string
+Version::VersionTag (void)
+{
+  return NS3_VERSION_TAG;
+}
+
+std::string
+Version::ClosestAncestorTag (void)
+{
+  return NS3_VERSION_CLOSEST_TAG;
+}
+
+uint32_t
+Version::Major (void)
+{
+  return NS3_VERSION_MAJOR;
+}
+
+uint32_t
+Version::Minor (void)
+{
+  return NS3_VERSION_MINOR;
+}
+
+uint32_t
+Version::Patch (void)
+{
+  return NS3_VERSION_PATCH;
+}
+
+std::string
+Version::ReleaseCandidate (void)
+{
+  return std::string{NS3_VERSION_RELEASE_CANDIDATE};
+}
+
+uint32_t
+Version::TagDistance (void)
+{
+  return NS3_VERSION_TAG_DISTANCE;
+}
+
+bool
+Version::DirtyWorkingTree (void)
+{
+  return static_cast<bool> (NS3_VERSION_DIRTY_FLAG);
+}
+
+std::string
+Version::CommitHash (void)
+{
+  return std::string{NS3_VERSION_COMMIT_HASH};
+}
+
+std::string
+Version::BuildProfile (void)
+{
+  return std::string{NS3_VERSION_BUILD_PROFILE};
+}
+
+std::string
+Version::ShortVersion (void)
+{
+  std::ostringstream ostream;
+  ostream << VersionTag (); 
+
+  auto ancestorTag = ClosestAncestorTag ();
+  if ( ( !ancestorTag.empty () && (ancestorTag != VersionTag ()) )
+       || TagDistance () > 0)
+    {
+      ostream << "+";
+    }
+  if (DirtyWorkingTree ())
+    {
+      ostream << "*";
+    }
+
+  return ostream.str ();
+}
+
+std::string
+Version::BuildSummary (void)
+{
+  std::ostringstream ostream;
+  ostream << ClosestAncestorTag ();
+
+  if (TagDistance () > 0)
+    {
+      ostream << "+";
+    }
+  if (DirtyWorkingTree ())
+    {
+      ostream << "*";
+    }
+
+  return ostream.str ();
+}
+
+std::string
+Version::LongVersion (void)
+{
+  std::ostringstream ostream;
+  ostream << VersionTag (); 
+
+  auto ancestorTag = ClosestAncestorTag ();
+  if ( !ancestorTag.empty () && (ancestorTag != VersionTag ()) )
+    {
+      ostream << '+' << ancestorTag;
+    }
+
+  auto tagDistance = TagDistance ();
+
+  if ( tagDistance > 0 )
+    {
+      ostream << '+' << tagDistance;
+    }
+
+  ostream << '@' << CommitHash ();
+
+  if ( DirtyWorkingTree () )
+    {
+      ostream << "-dirty";
+    }
+
+  ostream << '-' << BuildProfile ();
+
+  return ostream.str ();
+}
+
+}   // namespace ns3
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/version-defines.h.in ns-3.32/src/core/model/version-defines.h.in
--- ns-3.31/src/core/model/version-defines.h.in	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/model/version-defines.h.in	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,145 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Mathew Bielejeski <bielejeski1@llnl.gov>
+ */
+
+#ifndef NS3_VERSION_DEFINES_H_
+#define NS3_VERSION_DEFINES_H_
+
+/**
+  * \file
+  * \ingroup buildversion
+  * Defines the macro values for printing the build version.
+  * These will be populated by the build system.
+  */
+
+/**
+  * \ingroup buildversion
+  * @{
+  */
+
+/**
+ * The first tag found which matches the pattern ns-3*.
+ *
+ * The expected format of the ns-3 version tag is: ns-3.<minor>[.patch][-release_candidate]
+ *
+ * The tag is found by starting at the tip of the current branch and walking
+ * back towards the root.
+ *
+ * Type: string literal
+ */
+#define NS3_VERSION_TAG @VERSION_TAG@
+
+/**
+ * The tag closest to the tip of the current branch
+ *
+ * The tag is found by starting at the tip of the current branch and
+ * walking back towards the root.
+ *
+ * This value will be the same as #NS3_VERSION_TAG when #NS3_VERSION_TAG is
+ * the closest tag.
+ *
+ * Type: string literal
+ */
+#define NS3_VERSION_CLOSEST_TAG @CLOSEST_TAG@
+
+/**
+ * The major version extracted from #NS3_VERSION_TAG
+ *
+ * For a tag with the format ns-<digit>.<digit>[.digit], the major
+ * version is the number after ns- and before the first period.
+ *
+ * Type: integer
+ */
+#define NS3_VERSION_MAJOR @VERSION_MAJOR@
+
+/**
+ * The minor version extracted from #NS3_VERSION_TAG
+ *
+ * For a tag with the format ns-<digit>.<digit>[.digit], the minor
+ * version is the number after the first period.
+ *
+ * Type: integer
+ */
+#define NS3_VERSION_MINOR @VERSION_MINOR@
+
+/**
+ * The patch number extracted from #NS3_VERSION_TAG
+ *
+ * For a tag with the format ns-<digit>.<digit>[.digit], the patch
+ * is the number after the last period.
+ *
+ * The patch value is optional and may not be present in the tag.
+ * In cases where the patch value is not present, the field will be set to 0
+ *
+ * Type: integer
+ */
+#define NS3_VERSION_PATCH @VERSION_PATCH@
+
+/**
+ * The portion of the #NS3_VERSION_TAG indicating the version
+ * of the release candidate (if applicable).
+ *
+ * In order for this field to contain a value, the #NS3_VERSION_TAG
+ * must have the format ns-<digit>.<digit>[.digit][-RC<digit>].
+ * The contents of the release candidate will be the RC<digit>
+ * portion of the tag.
+ *
+ * Type: string literal
+ */
+#define NS3_VERSION_RELEASE_CANDIDATE @VERSION_RELEASE_CANDIDATE@
+
+/**
+ * The number of repository commits between #NS3_VERSION_CLOSEST_TAG
+ * and the branch HEAD.
+ *
+ * Type: integer
+ */
+#define NS3_VERSION_TAG_DISTANCE @VERSION_TAG_DISTANCE@
+
+/**
+ * Hash value which uniquely identifies the commit of the
+ * branch HEAD.
+ * The first character of the commit hash is 'g' to indicate this hash is
+ * a git hash
+ *
+ * Type: string literal
+ */
+#define NS3_VERSION_COMMIT_HASH @VERSION_COMMIT_HASH@
+
+/**
+ * Flag indicating whether the repository working tree had uncommitted
+ * changes when the library was built.
+ *
+ * The flag will be 1 if there were uncommitted changes, 0 otherwise.
+ *
+ * Type: integer
+ */
+#define NS3_VERSION_DIRTY_FLAG @VERSION_DIRTY_FLAG@
+
+/**
+ * Indicates the build profile that was specified by the --build-profile option
+ * of "waf configure"
+ *
+ * Type: string literal
+ */
+#define NS3_VERSION_BUILD_PROFILE "@BUILD_PROFILE@"
+
+/** @} */
+
+#endif
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/version.h ns-3.32/src/core/model/version.h
--- ns-3.31/src/core/model/version.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/model/version.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,275 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Mathew Bielejeski <bielejeski1@llnl.gov>
+ */
+
+#ifndef BUILD_VERSION_H_
+#define BUILD_VERSION_H_
+
+#include "ns3/int64x64.h" 
+#include <string>
+
+/**
+ * \file
+ * \ingroup buildversion
+ * class ns3::Version definition
+ */
+
+namespace ns3 {
+
+/**
+ * \ingroup core
+ * \defgroup buildversion Build version reporting
+ *
+ * Version information is pulled from the local git repository during the build
+ * process.  If a git repository is not found, the build system will search for 
+ * a file named version.cache under the src/core directory.  The version.cache 
+ * file must contain key/value pairs in the format key=value with one entry per 
+ * line. The build system will use the data pulled from the git repository, or 
+ * loaded from the version.cache file, to generate the file version-defines.h 
+ *
+ * The build will fail if a local git repository is not present and 
+ * a version.cache file can not be found.
+ */
+
+/**
+ * \ingroup buildversion
+ *
+ * Helper class providing functions to access various parts of the version
+ * string, as well as functions for composing short and long variants of the
+ * version string.
+ *
+ * See CommandLine::PrintVersion() for an example on how to
+ * use Version to output a version string.  command-line-example has been updated
+ * to include CommandLine::PrintVersion() in its output
+ *
+ * build-version-example.cc illustrates using each of these functions.
+ *
+ * Below is a partial view of a git branch:
+ *
+ * \note Square nodes represent tags
+ * \note Circle nodes represent commits
+ *
+ * \dot
+ * digraph {
+ *   vt [label="ns-3.32", shape="box"]
+ *   t  [label="mytag", shape="box"]
+ *   h  [label="HEAD", shape="box"]
+ *   c1 [label="6ad7f05"]
+ *   c2 [label="05fc891"]
+ *   c3 [label="bd9ffac"]
+ *   c4 [label="70fa23b"]
+ *
+ *   h -> c1 -> c2 -> c3 -> c4
+ *   t -> c2
+ *   vt -> c4
+ * }
+ * \enddot
+ *
+ * Here are the values that will be assigned based on this example branch:
+ *
+ * | Component          | Value    | Notes |
+ * |--------------------|----------|-------|
+ * | VersionTag         | ns-3.32  |       |
+ * | ClosestAncestorTag | mytag    |       |
+ * | Major              | 3        |       |
+ * | Minor              | 32       |       |
+ * | Patch              | 0        | This version tag does not have a patch field |
+ * | ReleaseCandidate   | ""       | This version tag does not have a release candidate field |
+ * | TagDistance        | 1        |       |
+ * | CommitHash         | g6ad7f05 | g at front of hash indicates a git hash |
+ * | DirtyWorkingTree   | Variable | Depends on status of git working and stage areas |
+ * | BuildProfile       | Variable | Depends on the value of --build-profile option of waf configure |
+ */
+class Version
+{
+public:
+  /**
+   * Returns the ns-3 version tag of the closest ancestor commit.
+   *
+   * The format of the tag is 
+   * \verbatim ns3-<major>.<minor>[.patch] \endverbatim
+   *
+   * The patch field is optional and may not be present.  The value of
+   * patch defaults to 0 if the tag does not have a patch field.
+   *
+   * \return ns-3 version tag
+   */
+  static std::string VersionTag (void);
+
+  /**
+   * Returns the closest tag that is attached to a commit that is an ancestor
+   * of the current branch head.
+   *
+   * The value returned by this function may be the same as VersionTag()
+   * if the ns-3 version tag is the closest ancestor tag.
+   *
+   * \return Closest tag attached to an ancestor of the current commit
+   */
+  static std::string ClosestAncestorTag (void);
+
+  /**
+   * Major component of the build version
+   *
+   * The format of the build version string is 
+   * \verbatim ns-<major>.<minor>[.patch][-RC<digit>] \endverbatim
+   *
+   * The major component is the number before the first period
+   *
+   * \return The major component of the build version
+   */
+  static uint32_t Major (void);
+
+  /**
+   * Minor component of the build version
+   *
+   * The format of the build version string is 
+   * \verbatim ns-<major>.<minor>[.patch][-RC<digit>] \endverbatim
+   *
+   * The minor component is the number after the first period
+   *
+   * \return The minor component of the build version
+   */
+  static uint32_t Minor (void);
+
+  /**
+   * Patch component of the build version
+   *
+   * A build version with a patch component will have the format
+   * \verbatim ns-<major>.<minor>.<patch> \endverbatim
+   *
+   * The patch component is the number after the second period
+   *
+   * \return The patch component of the build version or 0 if the build version
+   * does not have a patch component
+   */
+  static uint32_t Patch (void);
+
+  /**
+   * Release candidate component of the build version
+   *
+   * A build version with a release candidate will have the format
+   * \verbatim ns-<major>.<minor>[.patch]-RC<digit> \endverbatim
+   *
+   * The string returned by this function will have the format RC<digit>
+   *
+   * \return The release candidate component of the build version or an empty
+   * string if the build version does not have a release candidate component
+   */
+  static std::string ReleaseCandidate (void);
+
+  /**
+   * The number of commits between the current
+   * commit and the tag returned by ClosestAncestorTag().
+   *
+   * \return The number of commits made since the last tagged commit
+   */
+  static uint32_t TagDistance (void);
+
+  /**
+   * Indicates whether there were uncommitted changes during the build
+   *
+   * \return \c true if the working tree had uncommitted changes.
+   */
+  static bool DirtyWorkingTree (void);
+
+  /**
+   * Hash of the most recent commit
+   *
+   * The hash component is the id of the most recent commit.
+   * The returned value is a hexadecimal string with enough data to
+   * uniquely identify the commit.
+   *
+   * The first character of the string is a letter indicating the type
+   * of repository that was in use: g=git
+   *
+   * Example of hash output: g6bfb0c9
+   *
+   * \return hexadecimal representation of the most recent commit id
+   */
+  static std::string CommitHash (void);
+
+  /**
+   * Indicates the type of build that was performed (debug/release/optimized).
+   *
+   * This information is set by the --build-profile option of waf configure
+   *
+   * \return String containing the type of build
+   */
+  static std::string BuildProfile (void);
+
+  /**
+   * Constructs a string containing the ns-3 major and minor version components,
+   * and indication of additional commits or dirty status.
+   *
+   * The format of the constructed string is 
+   * \verbatim ns-<major>.<minor>[.patch][-rc]<flags> \endverbatim
+   *
+   *   * [patch] is included when Patch() > 0.
+   *   * [-rc] is included when ReleaseCandidate() contains a non-empty string
+   *   * \c flags will contain `+` when TagDistance() > 0
+   *   * \c flags will contain `*` when DirtyWorkingTree() == true.
+   *
+   * [flags] will contain none, one, or both characters depending on the state
+   * of the branch
+   *
+   * \return String containing the ns-3 major and minor components and flags.
+   */
+  static std::string ShortVersion (void);
+
+  /**
+   * Constructs a string containing the most recent tag and status flags.
+   *
+   * In the case where closest-ancestor-tag == version-tag, the output of this
+   * function will be the same as ShortVersion()
+   *
+   * The format of the constructed string is `<closest-ancestor-tag>[flags]`.
+   *
+   *   * \c flags will contain `+` when TagDistance() > 0
+   *   * \c flags will contain `*` when DirtyWorkingTree() == true.
+   *
+   * [flags] will contain none, one, or both characters depending on the state
+   * of the branch
+   *
+   * \return String containing the closest ancestor tag and flags.
+   */
+  static std::string BuildSummary (void);
+
+  /**
+   * Constructs a string containing all of the build details
+   *
+   * The format of the constructed string is
+   * \verbatim 
+   * ns-<major>.<minor>[.patch][-rc][-closest-tag]-<tag-distance>@<hash>[-dirty]-<build-profile>
+   * \endverbatim
+   *
+   * [patch], [rc], [closest-tag], and [dirty] will only be present under certain circumstances:
+   *   * [patch] is included when Patch() > 0
+   *   * [rc] is included when ReleaseCandidate() is not an empty string
+   *   * [closest-tag] is included when ClosestTag() != VersionTag()
+   *   * [dirty] is included when DirtyWorkingTree() is \c true
+   *
+   * \return String containing full version
+   */
+  static std::string LongVersion (void);
+
+};  // class Version
+
+}  // namespace ns3
+
+#endif
